/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2018 - 2023 Balthasar Weitzel, Dominik Schnier
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.business.grapevine.processors;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.tuple.Pair;
import org.springframework.beans.factory.annotation.Autowired;

import de.fhg.iese.dd.platform.business.communication.events.ChatMessageSendConfirmation;
import de.fhg.iese.dd.platform.business.communication.exceptions.InvalidChatMessageException;
import de.fhg.iese.dd.platform.business.communication.services.IChatService;
import de.fhg.iese.dd.platform.business.framework.events.EventExecutionStrategy;
import de.fhg.iese.dd.platform.business.framework.events.processing.BaseEventProcessor;
import de.fhg.iese.dd.platform.business.framework.events.processing.EventProcessing;
import de.fhg.iese.dd.platform.business.framework.events.processing.EventProcessor;
import de.fhg.iese.dd.platform.business.grapevine.events.chat.BaseChatStartRequest;
import de.fhg.iese.dd.platform.business.grapevine.events.chat.ChatStartOnCommentConfirmation;
import de.fhg.iese.dd.platform.business.grapevine.events.chat.ChatStartOnCommentRequest;
import de.fhg.iese.dd.platform.business.grapevine.events.chat.ChatStartOnPostConfirmation;
import de.fhg.iese.dd.platform.business.grapevine.events.chat.ChatStartOnPostRequest;
import de.fhg.iese.dd.platform.business.grapevine.events.suggestion.ChatStartWithSuggestionWorkerConfirmation;
import de.fhg.iese.dd.platform.business.grapevine.events.suggestion.ChatStartWithSuggestionWorkerRequest;
import de.fhg.iese.dd.platform.business.grapevine.exceptions.PostHasNoCreatorException;
import de.fhg.iese.dd.platform.business.grapevine.exceptions.PostNotFoundException;
import de.fhg.iese.dd.platform.business.grapevine.services.IGrapevineChatService;
import de.fhg.iese.dd.platform.business.grapevine.services.ISuggestionService;
import de.fhg.iese.dd.platform.datamanagement.communication.model.Chat;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatMessage;
import de.fhg.iese.dd.platform.datamanagement.grapevine.LoesBarConstants;
import de.fhg.iese.dd.platform.datamanagement.grapevine.model.Comment;
import de.fhg.iese.dd.platform.datamanagement.grapevine.model.Post;
import de.fhg.iese.dd.platform.datamanagement.grapevine.model.Suggestion;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;
import de.fhg.iese.dd.platform.datamanagement.shared.files.model.FileOwnership;
import de.fhg.iese.dd.platform.datamanagement.shared.files.model.TemporaryMediaItem;
import de.fhg.iese.dd.platform.datamanagement.shared.files.services.IMediaItemService;

@EventProcessor
class GrapevineChatEventProcessor extends BaseEventProcessor {

    @Autowired
    private IGrapevineChatService grapevineChatService;

    @Autowired
    private IChatService chatService;

    @Autowired
    private IMediaItemService mediaItemService;

    @Autowired
    private ISuggestionService suggestionService;

    @SuppressWarnings("Duplicates")
    @EventProcessing
    private ChatStartOnPostConfirmation handleChatStartOnPostRequest(ChatStartOnPostRequest event) {
        Person sender = event.getSender();
        Post post = event.getPost();
        Person receiver = post.getCreator();
        long sentTime = event.getSentTime();
        String message = event.getMessage();
        if (receiver == null) {
            throw new PostHasNoCreatorException("The post {} has no creator, so no chat can be started", post.getId());
        }
        Chat chat = grapevineChatService.findOrCreateChat(sender, receiver, post);
        chat = grapevineChatService.addPostReferenceToChat(chat, sender, post, sentTime).getLeft();
        //the autogenerated messages should just be a glimpse earlier, so we wait very shortly
        sleepForOneMilli();
        Pair<Chat, ChatMessage> chatAndAddedMessage = addMessageToChat(event, sender, sentTime, message, chat);
        return ChatStartOnPostConfirmation.builder()
                .post(post)
                .chat(chatAndAddedMessage.getLeft())
                .chatMessage(chatAndAddedMessage.getRight())
                .build();
    }

    @SuppressWarnings("Duplicates")
    @EventProcessing
    private ChatStartOnCommentConfirmation handleChatStartOnCommentRequest(ChatStartOnCommentRequest event) {
        Person sender = event.getSender();
        Comment comment = event.getComment();
        Person receiver = comment.getCreator();
        long sentTime = event.getSentTime();
        String message = event.getMessage();
        Chat chat = grapevineChatService.findOrCreateChat(sender, receiver, comment);
        chat = grapevineChatService.addCommentReferenceToChat(chat, sender, comment, sentTime).getLeft();
        //the autogenerated messages should just be a glimpse earlier, so we wait very shortly
        sleepForOneMilli();
        Pair<Chat, ChatMessage> chatAndAddedMessage = addMessageToChat(event, sender, sentTime, message, chat);
        return ChatStartOnCommentConfirmation.builder()
                .comment(comment)
                .chat(chatAndAddedMessage.getLeft())
                .chatMessage(chatAndAddedMessage.getRight())
                .build();
    }

    @EventProcessing
    private ChatStartWithSuggestionWorkerConfirmation handleChatStartWithSuggestionWorkerRequest(ChatStartWithSuggestionWorkerRequest event) {
        Person sender = event.getSender();
        Person receiver = event.getReceiver();
        long sentTime = event.getSentTime();
        String message = event.getMessage();
        Suggestion suggestion = event.getSuggestion();
        //we create the suggestion worker private chats as dorffunk chats, so that they can be seen also in the dorffunk app
        Chat chat = grapevineChatService.findOrCreateChat(sender, receiver, receiver);
        // add the suggestion to the chat, if it was passed in the event
        if (suggestion != null) {
            chat = grapevineChatService.addPostReferenceToChat(chat, sender, suggestion, sentTime).getLeft();
            //the autogenerated messages should just be a glimpse earlier, so we wait very shortly
            sleepForOneMilli();
        }
        Pair<Chat, ChatMessage> chatAndAddedMessage = addMessageToChat(event, sender, sentTime, message, chat);
        return ChatStartWithSuggestionWorkerConfirmation.builder()
                .chat(chatAndAddedMessage.getLeft())
                .chatMessage(chatAndAddedMessage.getRight())
                .build();
    }

    @EventProcessing(executionStrategy = EventExecutionStrategy.ASYNCHRONOUS_PREFERRED)
    private void handleChatMessageSendConfirmation(ChatMessageSendConfirmation chatMessageSendConfirmation) {
        if (!StringUtils.equals(chatMessageSendConfirmation.getChatMessage().getChat().getTopic(),
                LoesBarConstants.SUGGESTION_INTERNAL_WORKER_CHAT_TOPIC)) {
            return;
        }
        ChatMessage chatMessage = chatMessageSendConfirmation.getChatMessage();
        try {
            Suggestion suggestion = suggestionService
                    .findSuggestionByInternalWorkerChatIncludingOverrideDeleted(chatMessage.getChat(), false);
            suggestion.setLastSuggestionActivity(chatMessage.getSentTime());
            suggestionService.store(suggestion);
        } catch (PostNotFoundException e) {
            log.error("Failed to find suggestion by internal chat {}", chatMessage.getChat().getId());
        }
    }

    private Pair<Chat, ChatMessage> addMessageToChat(BaseChatStartRequest event, Person sender, long sentTime,
            String message, Chat chat) {

        TemporaryMediaItem temporaryMediaItem = event.getTemporaryMediaItem();
        if (temporaryMediaItem == null) { //if the temporaryMediaItem is null, then there should be a message
            if (StringUtils.isNotEmpty(message)) {
                return chatService.addUserTextMessageToChat(chat, sender, message, sentTime);
            } else {
                throw new InvalidChatMessageException("TemporaryMediaItem and Message cannot be both null");
            }
        } else {
            return chatService.addUserMediaMessageToChat(chat, sender, message,
                    mediaItemService.useItem(temporaryMediaItem,
                            FileOwnership.of(temporaryMediaItem.getOwner(), event.getAppVariant())),
                    sentTime);
        }
    }

    private void sleepForOneMilli() {
        try {
            Thread.sleep(1);
        } catch (InterruptedException e) {
            Thread.currentThread().interrupt();
        }
    }

}
